#!/bin/sh

# parameter setup
module="./security.o"     # otherwise use this one.
device="security"
group="sys"
mode="666"

# invoke insmod with all arguments given to us
/sbin/insmod -f $module $* || exit 1

# remove stale nodes
rm -f /dev/${device}

major=`cat /proc/devices | awk "\\$2==\"$device\" {print \\$1}"`

mknod /dev/${device} c $major 0

# give appropriate group/permissions
chgrp $group /dev/${device}
chmod $mode  /dev/${device}



