/*
 * Thanks to Scot Laird, Russell Nelson, and others..
 *
 * Copyright (C) 1996 by Thomas Davis
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL SCOTT LAIRD BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include "quickcam.h"

main()
{
	int fd;
	int ret;
	int count;
	unsigned char buf[FRAME_BUFFER_SIZE];
   
	fprintf(stderr, "ctest start\n");
   
	fd = open("/dev/quickcam", O_RDONLY );

	if (fd < 0) {
		fprintf(stderr, "ctest open failed with %d \n", fd);
		exit(1);
	}

	fprintf(stderr, "ctest opened device \n");

	count = FRAME_BUFFER_SIZE;

	ret = read(fd, buf, count);

	fprintf(stderr, "ctest read %d bytes (%d requested)\n", ret, count);

	close(fd);

	fprintf(stderr, "ctest closed device\n");

	printf("P5\n320 240\n64\n");

	for(count = 0; count < FRAME_BUFFER_SIZE; count++ ) {
		putchar(buf[count]);
	}

	fprintf(stderr, "ctest done\n");
	exit(0);
}
