/*
 * Thanks to Scot Laird, Russell Nelson, and others..
 *
 * Copyright (C) 1996 by Thomas Davis
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL SCOTT LAIRD BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

/*
 * This can still benefit from simple reordering of the shifts..
 */

/*
 * Before making any major changes, please look at the assembler output.
 * You may be suprised at what you get..
 */

#define __KERNEL__
#define MODULE

#include <linux/kernel.h>
#include <asm/io.h>

#include "quickcam.h"
#include "qcam-kernel.h"

void uni_6bit(struct quickcam *qc)
{
	unsigned int word1, word2, word3;
	unsigned char *tmp = qc->buffer;

	if (qc->debug > 1)
		printk("starting uni_6bit scan..\n");

	outb(0x06, qc->port+2);

	while (tmp < qc->buffer + (qc->xsize * (qc->ysize))) {
		do {
			word1 = inb(qc->port+1);
		} while (!(word1 & 0x08));

		outb(0x0e, qc->port+2);

		word2 = word1 & 0xf0;

		do {
			word1 = inb(qc->port+1);
		} while (word1 & 0x08);

		outb(0x06, qc->port+2);

		word2 = word2 | ((word1 & 0xf0) >> 4);
		*tmp++ = 63 - ((word2 >> 2) & 0x3f);

		do {
			word1 = inb(qc->port+1);
		} while (!(word1 & 0x08));

		outb(0x0e, qc->port+2);

		word3 = word2;
		word2 = word1 & 0xf0;

		do {
			word1 = inb(qc->port+1);
		} while (word1 & 0x08);

		outb(0x06, qc->port+2);

		word2 = word2 | ((word1 & 0xf0) >> 4);
		*tmp++ = 63 - (((word3 & 0x03) << 4) | (word2 >> 4));

		do {
			word1 = inb(qc->port+1);
		} while (!(word1 & 0x08));

		outb(0x0e, qc->port+2);

		word3 = word2;
		word2 = word1 & 0xf0;

		do {
			word1 = inb(qc->port+1);
		} while (word1 & 0x08);

		outb(0x06, qc->port+2);

		word2 = word2 | ((word1 & 0xf0) >> 4);
		*tmp++ = 63 - (((word3 & 0x0f) << 2) | ( word2 >> 6));
		*tmp++ = 63 - (word2 & 0x3f);
	}

	outb(0x0e, qc->port + 2);

	do {
		word2 = inb(qc->port + 1);
	} while (word2 & 0x08);

	outb(0x06, qc->port + 2);

	do {
		word1 = inb(qc->port + 1);
	} while (word1 & 0x08);

	outb(0x0f, qc->port + 2);

	if (qc->debug > 1)
		printk("uni_6bit done.\n");

}

